package com.gxwebsoft.shop.controller;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.shop.entity.UserReferee;
import com.gxwebsoft.shop.param.UserRefereeParam;
import com.gxwebsoft.shop.service.UserRefereeService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 用户推荐关系表控制器
 *
 * @author 科技小王子
 * @since 2023-04-28 14:07:29
 */
@Api(tags = "用户推荐关系表管理")
@RestController
@RequestMapping("/api/shop/user-referee")
public class UserRefereeController extends BaseController {
    @Resource
    private UserRefereeService userRefereeService;

    @PreAuthorize("hasAuthority('shop:userReferee:list')")
    @OperationLog
    @ApiOperation("分页查询用户推荐关系表")
    @GetMapping("/page")
    public ApiResult<PageResult<UserReferee>> page(UserRefereeParam param) {
//        PageParam<UserReferee, UserRefereeParam> page = new PageParam<>(param);
//        page.setDefaultOrder("create_time desc");
//        return success(userRefereeService.page(page, page.getWrapper()));
        // 使用关联查询
        return success(userRefereeService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('shop:userReferee:list')")
    @OperationLog
    @ApiOperation("查询全部用户推荐关系表")
    @GetMapping()
    public ApiResult<List<UserReferee>> list(UserRefereeParam param) {
        // 贵港自然资源局定制
        if(getTenantId().equals(10048)){
          final List<UserReferee> userRefereeList = userRefereeService.listRel(param);
          final User user = getLoginUser();
          final UserReferee userReferee = new UserReferee();
          userReferee.setNickname(user.getNickname());
          userRefereeList.add(userReferee);
          return success(userRefereeList);
        }
        // 使用关联查询
        return success(userRefereeService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:userReferee:list')")
    @OperationLog
    @ApiOperation("根据id查询用户推荐关系表")
    @GetMapping("/{id}")
    public ApiResult<UserReferee> get(@PathVariable("id") Integer id) {
//        return success(userRefereeService.getById(id));
        // 使用关联查询
        return success(userRefereeService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('shop:userReferee:save')")
    @OperationLog
    @ApiOperation("添加用户推荐关系表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody UserReferee userReferee) {
//        if(userReferee.getDealerId().equals(userReferee.getUserId())){
//          return fail("不能邀请自己");
//        }
        final int count = userRefereeService.count(new LambdaQueryWrapper<UserReferee>()
          .eq(UserReferee::getUserId, userReferee.getUserId())
          .eq(UserReferee::getDealerId,userReferee.getDealerId())
        );
        if(count > 0){
          return fail("关系已存在");
        }
        if (userRefereeService.save(userReferee)) {
              return success("添加成功");
          }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:userReferee:update')")
    @OperationLog
    @ApiOperation("修改用户推荐关系表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody UserReferee userReferee) {
        if (userRefereeService.updateById(userReferee)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:userReferee:remove')")
    @OperationLog
    @ApiOperation("删除用户推荐关系表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (userRefereeService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('shop:userReferee:save')")
    @OperationLog
    @ApiOperation("批量添加用户推荐关系表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<UserReferee> list) {
        if (userRefereeService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:userReferee:update')")
    @OperationLog
    @ApiOperation("批量修改用户推荐关系表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<UserReferee> batchParam) {
        if (batchParam.update(userRefereeService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:userReferee:remove')")
    @OperationLog
    @ApiOperation("批量删除用户推荐关系表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (userRefereeService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
